#!/usr/bin/perl
$program = "LogScribe";
$version = "1.0";

#=====================================================#
# This file's name: config.pl                         #
# This is the configuration file for LogScribe        #
#                                                     #
# LogScribe -  by Usama Wazeer (usamaw@cs.utexas.edu) #
#              http://www.cs.utexas.edu/users/usamaw  #
#           - and Daniel Cedras (cedras@texas.net)    #
#              http://www.texas.net/~cedras/html      #
#=====================================================#


#------------------------------------#
# How many days do you want to log ? #
#------------------------------------#
$numofdays = 30;

#----------------------------------------#
# Our logfile - This is where the server #
# will log all connections to your pages #
#----------------------------------------#
$logfile = "/home/jang22/web/cgi-pub/logscribe/access.log";

#-------------------------------------------#
# Our backup logfile - This is where the    #
# program will make a backup copy of the    #
# logfile to reduce your risks of losing it #
# This is mandatory !                       #
#-------------------------------------------#
$backup = "/home/jang22/web/cgi-pub/logscribe/access.bak";

#------------------------------------------------------#
# Our lockfile (prevents erroneous logfile overwrites) #
# This is mandatory !                                  #
#------------------------------------------------------#
$lockfile = "/home/jang22/web/cgi-pub/logscribe/access.lok";

#----------------------------------------------------#
# If you want your old accesses to be automatically  #
# archived to a file, set the path/name of that file #
# in the variable below and remove the '#' in front  #
# of the variable name if one exists.  Otherwise,    #
# add a '#' in front of the variable name to turn    #
# off that option.                                   #
# examples:                                          #
# # $oldlogfile = "";  <-- deactivates option        #
# $oldlogfile = "access.old" <-- activates option    #
#                                                    #
# This is optional                                   #
#----------------------------------------------------#
$oldlogfile = "/home/jang22/web/cgi-pub/logscribe/access.old";
 
#-----------------------------#
# The URL to your showlog.pl  #
#-----------------------------#
$showlogurl = "http://www.dadream.co.kr/~jang22/cgi-pub/logscribe/showlog.cgi";

#----------------------------#
# The URL to your pagelog.pl #
#----------------------------#
$pagelogurl = "http://www.dadream.co.kr/~jang22/cgi-pub/logscribe/pagelog.cgi";

#--------------------------------#
# The URL to the directory where #
# you want your gif files stored #
#--------------------------------#
$gifdirurl = "http://www.dadream.co.kr/~jang22/cgi-pub/logscribe";

#-------------------------------------------------------------------------#
# Sites which should be allowed to ADD to your log. This should be a list #
# of sites where you have pages you would like to maintain logs for. This #
# is a security feature to ensure that users outside of that list aren't  # 
# able to remotely add fictitious pages to your log file.                 #
# Make sure to either set it to your site or to nothing or else the       #
# program will NOT work !!!!                                              #
#-------------------------------------------------------------------------#
# Example:                                                                #
# a single site:                                                          #
# @referers = ('www.texas.net/~cedras');                                  #
# multiple sites:                                                         #
# @referers = ('www.ios.com/~cedras', 'www.texas.net/~cedras');           #
# to disable the security feature:                                        #
# @referers = ();                                                         #
#-------------------------------------------------------------------------#
@referers = ('www.dadream.co.kr/~jang22');

#-------------------------------------------------------------#
# If you get connections from the following sites, then those #
# sites are ignored and are not logged.  This is especially   #
# good for people who are creating their own web pages and do #
# not want their access logged every time they are testing to #
# see if their web pages look good -                          #
#-------------------------------------------------------------#
# Example:                                                    #
# a single site:                                              #
# @ignoresites = ('millenium.texas.net');                     #
# multiple sites:                                             #
# @ignoresites = ('haven.ios.com','.shadow.net');             #
# doing this will log everyone:                               #
# @ignoresites = ();                                          #
#-------------------------------------------------------------#
@ignoresites = ('.shadow.net');

#---------------------------------------------------------#
# Set this to display the last X connections to your site #
#---------------------------------------------------------#
$connections = 100;

#---------------------------------------------------#
# Do you want to take out the machine name in the   #
# names of the hosts that connect to your site ?    #
# This is a good idea - It will prevent your stats  #
# page from growing too large and will generalize   #
# the statistics per domain instead of per machine. #
# Set this to 0 to strip out the machine name       #
#---------------------------------------------------#
$fullhost = 0;

#------------------------------------------#
# Here you configure the colors/background #
# settings of your stats pages             #
#------------------------------------------#
# For the settings below, to make any of   #
# them active, remove the commenting       #
# character '#' in front of the setting    #
# that you want to enable, and fill out    #
# the appropriate color code/imagename     #
# Example:                                 #
# # $bgcolor = "BGCOLOR=";                 #
# to activate this item, remove the '#' in #
# front of it and fill in the appropriate  #
# value:                                   #
# $bgcolor = "BGCOLOR=#FFFFFF";            #
# To deactivate, just re-add the '#'       #
#------------------------------------------#
# Page background image:
# $background = "BACKGROUND=";
# Page background color:
$bgcolor = "BGCOLOR=#FFFFFF";
# Text color:
$textcolor = "TEXT=#853A00";
# Link color:
$linkcolor = "LINK=#0000FF";
# Visited link color:
$vlinkcolor = "VLINK=#FF0000";
# Active link color:
$alinkcolor = "ALINK=#000000";
# Table header background color:
$tableheadercolor = "BGCOLOR=#F4DCD0";
# Table border around hour/date charts:
$border = "BORDER=3";

#------------------------------------------#
# You can limit the number of hostnames,   #
# pages, browsers and days displayed on    #
# either the 'View All Statistics' page    #
# or on the 'View Stats by Hostname/Page/  #
# Browser/Day' pages - setting the numbers #
# below will display only the top X        #
# hostnames, pages, browsers, and last X   #
# days. Note: 'page' means for the         #
# related single page, and 'all' is for    #
# the 'View All Statistics' page.          #
# Setting the number to 0 removes limit    #
#------------------------------------------#
$limitpages{'all'} = 0;
$limitpages{'page'} = 0;
$limithosts{'all'} = 15;
$limithosts{'page'} = 25;
$limitbrowsers{'all'} = 10;
$limitbrowsers{'page'} = 10;
$limitdays{'all'} = 10;
$limitdays{'page'} = 0;


#-----------------------------#
# Do NOT touch the line below #
#-----------------------------#
1;
