#!/usr/bin/perl
$curpath = substr($0, 0, rindex($0, "/")+1);
require "${curpath}config.pl";

#=====================================================#
# This file's name: showlog.pl                        #                      
# This file presents your accesslog in a graphical    #
# manner                                              #
#                                                     #
# LogScribe -  by Usama Wazeer (usamaw@cs.utexas.edu) #
#              http://www.cs.utexas.edu/users/usamaw  #
#           - and Daniel Cedras (cedras@texas.net)    #
#              http://www.texas.net/~cedras/html      #
#=====================================================#


#==============================#
# Open the logfile and read it #
#==============================#
open (LOG,"$logfile");
while (<LOG>) {if ($_ ne "LOG-BEGIN\n") {push(@lines,$_);}};
close(LOG);


#============================================#
# Extract the data from each line of the log #
#============================================#
$i=0;
$currentdate="";

foreach (@lines) {
 ($thedate,$hostname,$pagename,$pageurl,$browser) = split;
 ($second,$minute,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime($thedate);
 $day=(Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday)[(localtime($thedate))[6]];
 $month=(Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[(localtime($thedate))[4]];
 $date="$mday/$month/$year";
 $mon = $mon + 1;
 $firstdate = "$mon/$mday/$year";

 if ($fullhost != 1) {&striphost};

 # replace '=' by ' ' in pagename if it's more than 1 word
 $pagename =~ s/=/ /g;

 if ($date eq $currentdate) { $counter[$i]++; }
 else { $i++; $currentdate=$date; $counter[$i]++; }

 ($lastdate) || ($lastdate="$mon/$mday/$year");
 ($date,$month,$year)=split('/',$date);

 # Increment the totals
 $days{$day}++;
  
 $dates{$date}++;
 $thedates{$thedate}++;
 $hours{$hour}++;
 $pagenames{$pagename}++;
 $pageurls{$pageurl}++;
 if (!$pageindex{$pagename}) { $pageindex{$pagename}=$pageurl; }
 $pageindex{$pagename}=$pageurl;
 $hostnames{$hostname}++;
 $browsers{$browser}++;
 $nooflines=$#lines+1;
 }


#==================================#
# Strip the machine name if needed #
#==================================#
sub striphost {
 if ($hostname !~ /^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$/) {
  if ($hostname =~ /.*\..*\..*/) {
   # Only strip if we have at least 2 .'s
   $hostname = substr($hostname, index($hostname, ".")+1);
   while ($hostname =~ /.*\..*\..*\..*\..*/) {
    # We want no more thann 4 .'s
    $hostname = substr($hostname, index($hostname, ".")+1);
    }
   $hostname = ".$hostname";
   }
  } else {$hostname = substr($hostname, 0, rindex($hostname, ".")+1);}
 }


#==========================#
# Start writing the output #
# to the browser           #
#==========================#
# Speed up output:
$! = 1;
$| = 1;
print "Content-type: text/html\n\n";
print <<EOF;
<HTML>
 <HEAD><TITLE>$program</TITLE></HEAD>
 <BODY $background $bgcolor $textcolor $linkcolor $vlinkcolor $alinkcolor >
  <CENTER>
   <FONT SIZE=6><B><U>$program</U> </B></FONT><FONT SIZE=2><B>V $version</B></FONT><BR>
   <B>ٽð:</B> $firstdate <B>to</B> $lastdate <BR>
   <B>ü :</B> $nooflines<BR>
   <HR>
  </CENTER>
EOF


#=====================================#
# Ok, what did we pick in the menu..? #
#=====================================#
if ($ENV{'QUERY_STRING'} eq "allstats") {
 &by_connections;
 &by_time;
 }
if ($ENV{'QUERY_STRING'} eq "connections")
 {&by_connections;}
if ($ENV{'QUERY_STRING'} eq "page")
 {$showstats="page";&by_page;}
if ($ENV{'QUERY_STRING'} eq "browser")
 {$showstats="page";&by_browser;}
if ($ENV{'QUERY_STRING'} eq "hostname")
 {$showstats="page";&by_hostname;}

if ($ENV{'QUERY_STRING'} eq "time")
 {&by_time;}
if ($ENV{'QUERY_STRING'} eq "day")
 {$showstats="page";&by_day;}
if ($ENV{'QUERY_STRING'} eq "dayweek")
 {&by_dayweek;}
if ($ENV{'QUERY_STRING'} eq "daymonth")
 {&by_daymonth;}
if ($ENV{'QUERY_STRING'} eq "hour")
 {&by_hour;}

if ($ENV{'QUERY_STRING'} eq "allconnections")
 {&allconnections;}

if ($ENV{'QUERY_STRING'} eq "")
 {&no_argument;}

sub by_connections {
 $showstats="all";
 &by_page;
 &by_browser;
 &by_hostname;
 }

sub by_time {
 $showstats="all";
 &by_dayweek;
 &by_daymonth;
 &by_hour;
 &by_day;
 }

sub no_argument {
 undef $key;
 undef $insanepageref;
 print<<EOF;
  <CENTER>
   <TABLE BORDER=1 CELLPADDING=10 CELLSPACING=0>
    <TR>
     <TH $tableheadercolor>
      <A TARGET="_top" HREF="$showlogurl?allstats"><FONT SIZE=4>ü  </FONT></A>
     </TH>
     <TH $tableheadercolor>
      <A TARGET="_top" HREF="$pagelogurl"><FONT SIZE=4>  </FONT></A>
     </TH>
     <TH $tableheadercolor>
      <A TARGET="_top"><FONT SIZE=4><U>ְ </U></FONT></A>
     </TH>
    </TR>
    <TR>
     <TD NOWRAP>
      <UL>
       <LI><A TARGET="_top" HREF="$showlogurl?connections"><FONT SIZE=3> </FONT></A>
       <UL>
        <LI><A TARGET="_top" HREF="$showlogurl?page"></A>
        <LI><A TARGET="_top" HREF="$showlogurl?browser"></A>
        <LI><A TARGET="_top" HREF="$showlogurl?hostname">ȣƮ </A>
       </UL>
       <BR><BR>
       <LI><A TARGET="_top" HREF="$showlogurl?time"><FONT SIZE=3> </FONT></A>
       <UL>
        <LI><A TARGET="_top" HREF="$showlogurl?day"></A>
        <LI><A TARGET="_top" HREF="$showlogurl?dayweek">ְ </A>
        <LI><A TARGET="_top" HREF="$showlogurl?daymonth"> </A>
        <LI><A TARGET="_top" HREF="$showlogurl?hour">ȣƮ </A>
       </UL>
      </UL>
     </TD>
     <TD NOWRAP>
      <UL>
EOF
 sub sortbypage { $pagenames{$b} <=> $pagenames{$a}; };
 foreach $key (sort sortbypage keys(%pagenames)) {
  $insanepageref=$key;
  $insanepageref=~ s/ /=/g;
  print "       <LI><A TARGET=\"_top\" HREF=\"$pagelogurl?=,=,$insanepageref,$pageindex{$key},=\">$key</A>\n";
  }
  
 print<<EOF;
      </UL>
     </TD>
     <TD>
      <TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0>
EOF
 print "       <TR><TD>\n";
 &kwik_page;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_browser;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_hostname;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_day;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_dayweek;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_daymonth;
 print "       </TD></TR>\n       <TR><TD>\n";
 &kwik_hour;
 &kwik_today;
 print "       </TD></TR>\n";
 print<<EOF;
      </TABLE>
     </TD>
    </TR> 
   </TABLE>
   <HR>
  </CENTER>
EOF
 }


#===============#
# Stats by page #
#===============#
sub by_page {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef %oururls;
 undef $decimal;
 undef $insanepageref;
 undef $key;
 undef $pagecounter;
 undef $maxpages;

 foreach $key (sort keys %pagenames) {
  if ($pagenames{$key} > $highest) {$highest=$pagenames{$key};}
  }
 foreach $key (keys %pagenames) {
  $barsize{$key} = int(($pagenames{$key} * 250) / $highest);
  $percent{$key} = ($pagenames{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 print "  <H2><U>  </U></H2>\n";
 $maxpages = keys %pagenames;
 $maxlimit = $limitpages{$showstats};
  if ($maxlimit > $maxpages) {$maxlimit = $maxpages;}
 if ( ($maxlimit > 0) && ($maxlimit != $maxpages) )
  {print"  (<I>Now showing top $maxlimit pages out of a total of $maxpages</I>)<BR>\n";}
  else {$maxlimit = keys %pagenames;}
 print "  <TABLE>\n";
 sub sortbypage { $pagenames{$b} <=> $pagenames{$a}; };
 foreach $key (sort sortbypage keys(%pagenames)) {
  $insanepageref=$key;
  $insanepageref=~ s/ /=/g;
  if ($pagecounter < $maxlimit) {
   print<<EOF;
   <TR>
    <TH ALIGN=RIGHT><A TARGET="_top" HREF="$pageindex{$key}">$key</A>:</TH>
    <TD NOWRAP ALIGN=LEFT>
     <IMG BORDER=1 SRC="$gifdirurl/dot1.gif" HEIGHT=10 WIDTH=$barsize{$key}>
     <A TARGET="_top" HREF="$pagelogurl?=,=,$insanepageref,$pageindex{$key},=">$pagenames{$key}</A>
     <I> ($percentage{$key} %)</I>
    </TD>
   </TR>
EOF
   $pagecounter++;
   }
  }
 print "  </TABLE>\n";
 print "  <P><HR><P>\n";
 }


#==================#
# Stats by browser #
#==================#
sub by_browser {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;
 undef $browsercounter;
 undef $maxbrowsers;

 foreach $key (keys %browsers) {
  if ($browsers{$key} > $highest) {$highest=$browsers{$key};}
  }
 foreach $key (keys %browsers) {
  $barsize{$key} = int(($browsers{$key} * 250) / $highest);     
  $percent{$key} = ($browsers{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 print "  <H2><U> </U></H2>\n";
 $maxbrowsers = keys %browsers;
 $maxlimit = $limitbrowsers{$showstats};
 if ($maxlimit > $maxbrowsers) {$maxlimit = $maxbrowsers;}
 if ( ($maxlimit > 0) && ($maxlimit != $maxbrowsers) )
  {print"  (<I>Now showing top $maxlimit browsers out of a total of $maxbrowsers</I>)<BR>\n";}
  else {$maxlimit = keys %browsers;}
 print "  <TABLE>\n";
 sub sortbybrowser { $browsers{$b} <=> $browsers{$a}; };
 foreach $key (sort sortbybrowser keys(%browsers)) {
  if ($browsercounter < $maxlimit) {
   print<<EOF;
   <TR>
    <TH ALIGN=RIGHT>$key:</TH>
    <TD NOWRAP ALIGN=LEFT>
     <IMG BORDER=1 SRC="$gifdirurl/dot1.gif" HEIGHT=10 WIDTH=$barsize{$key}>
     <A TARGET="_top" HREF="$pagelogurl?=,=,=,=,$key">$browsers{$key}</A>
     <I> ($percentage{$key} %)</I>
    </TD>
   </TR>
EOF
   $browsercounter++;
   }
  }
 print "  </TABLE>\n";
 print "  <P><HR><P>\n";
 }


#===================#
# Stats by hostname #
#===================#
sub by_hostname {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $space;
 undef $key;
 undef $hostcounter;
 undef $maxhosts;

 if ($fullhost != 1) {$space = " ";} else {$space = "";}
 foreach $key (keys %hostnames) {
  if ($hostnames{$key} > $highest) {$highest=$hostnames{$key};}
  }
 foreach $key (keys %hostnames) {
  $barsize{$key} = int(($hostnames{$key} * 250) / $highest);
  $percent{$key} = ($hostnames{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
  {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 print "  <H2><U>ȣƮ </U></H2>\n";
 $maxhosts = keys %hostnames;
 $maxlimit = $limithosts{$showstats};
 if ($maxlimit > $maxhosts) {$maxlimit = $maxhosts;}
 if ( ($maxlimit > 0) && ($maxlimit != $maxhosts) )
  {print"  (<I>Now showing top $maxlimit hostnames out of a total of $maxhosts</I>)<BR>\n";}
  else {$maxlimit = keys %hostnames;}
 print "  <TABLE>\n";
 sub sortbyhostname { $hostnames{$b} <=> $hostnames{$a}; };
 foreach $key (sort sortbyhostname keys(%hostnames)) {
  if ($hostcounter < $maxlimit) {
   print<<EOF;
   <TR>
    <TH ALIGN=RIGHT>$key$space:</TH>
    <TD NOWRAP ALIGN=LEFT>
     <IMG BORDER=1 SRC="$gifdirurl/dot1.gif" HEIGHT=10 WIDTH=$barsize{$key}>
     <A TARGET="_top" HREF="$pagelogurl?=,$key,=,=,=">$hostnames{$key}</A>
     <I> ($percentage{$key} %)</I>
    </TD>
   </TR>
EOF
   $hostcounter++;
   }
  }
 print "  </TABLE>\n";
 print "  <P><HR><P>\n";
 }


#==========================#
# Stats by day of the week #
#==========================#
sub by_dayweek {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;

 foreach $key (keys %days) {
  if ($days{$key} > $highest) {$highest=$days{$key};}
  }
 foreach $key (keys %days) {
  $barsize{$key} = int(($days{$key} * 250) / $highest);
  $percent{$key} = ($days{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  if ($percentage{$key} == 0) 
   {$showpercent{$key}="";}else{$showpercent{$key}="($percentage{$key} %)";}
  }
 print "  <H2><U>ְ </U></H2>\n";
 print "  <TABLE>\n";
 foreach $key (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday) {
  print<<EOF;
   <TR>
    <TH ALIGN=RIGHT>$key:</TH>
    <TD NOWRAP ALIGN=LEFT>
     <IMG BORDER=1 SRC="$gifdirurl/dot1.gif" HEIGHT=10 WIDTH=$barsize{$key}>
     <B>$days{$key}</B> <I> $showpercent{$key}</I>
    </TD>
   </TR>
EOF
  }
 print "  </TABLE>\n";
 print "  <P><HR><P>\n";
 }


#===========================#
# Stats by day of the month #
#===========================#
sub by_daymonth {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;

 foreach $key (keys %dates) {
  if ($dates{$key} > $highest) {$highest=$dates{$key};}
  }
 foreach $key (keys %dates) {
  $barsize{$key} = int(($dates{$key} * 250) / $highest);
  }
 print "  <H2><U> </U></H2>\n";
 print "  <TABLE $border>\n   <TR>\n";
 foreach $key (1..31) {
  ($barsize{$key} < 2) && ($barsize{$key}=2);
  print <<EOF;
    <TD ALIGN=CENTER VALIGN=BOTTOM>
     <I>$dates{$key}</I><BR>
     <IMG BORDER=1 SRC="$gifdirurl/dot3.gif" HEIGHT=$barsize{$key} WIDTH=10>
    </TD>
EOF
  }
 print "   </TR>\n   <TR>\n";
 foreach $key (1..31) {print "    <TH ALIGN=CENTER>$key</TH>\n";}
 print "   </TR>\n  </TABLE>\n  <P><HR><P>\n";
 }


#===============#
# Stats by hour #
#===============#
sub by_hour {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;

 foreach $key (keys %hours) {
  if ($hours{$key} > $highest) {$highest=$hours{$key};}
  }
 foreach $key (keys %hours) {
  $barsize{$key} = int(($hours{$key} * 250) / $highest);
  }
 print "  <H2><U>ð </U></H2>\n";
 print "  <TABLE $border>\n   <TR>\n";
 foreach $key (0..23) {
  ($barsize{$key} < 2) && ($barsize{$key}=2);
  print <<EOF;
    <TD ALIGN=CENTER VALIGN=BOTTOM>
     <I>$hours{$key}</I><BR>
     <IMG BORDER=1 SRC="$gifdirurl/dot2.gif" HEIGHT=$barsize{$key} WIDTH=10>
    </TD>
EOF
  }
 print "   </TR>\n   <TR>\n";
 foreach $key (0..23) {
  if ($key > 11) 
   {$time_notation = "pm";}else{$time_notation = "am";}
  if ($key > 12) {$realtime = $key - 12;}else{$realtime = $key;}   
  if ($key == 0) {$realtime = "12";$time_notation = "am";} 
  print "    <TH ALIGN=CENTER>$realtime</TH>\n";
  }
 print "   </TR>\n";
 print "   <TR><TH COLSPAN=12>AM</TH><TH COLSPAN=12>PM</TH></TR>\n";
 print "  </TABLE>\n  <P><HR><P>\n";
 }


#==============#
# Stats by day #
#==============#
sub by_day {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;
 undef $daycounter;
 undef $maxdays;
 undef %realdates;
 undef %realdatesref;

 foreach $key (keys %thedates) {
  ($junk,$junk,$junk,$mday,$mon,$year,$junk,$junk,$junk)=localtime($key);
  $mon = $mon + 1;
  $realdate = sprintf ("%2d/%2d/%2d",$mon,$mday,$year);
  $realdate =~ s/ /0/g;
  $realdates{$realdate} = $realdates{$realdate} + $thedates{$key};
  $realdatesref{$realdate}=$key;
  }
 foreach $key (keys %realdates) {
  if ($realdates{$key} > $highest) { $highest=$realdates{$key};}  
  }
 foreach $key (keys %realdates) {
  $barsize{$key} = int(($realdates{$key} * 250) / $highest);
  $percent{$key} = ($realdates{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  if ($percentage{$key} == 0) 
   {$showpercent{$key}="";}else{$showpercent{$key}="($percentage{$key} %)";}
  }
 print "  <H2><U>Ϻ </U></H2>\n";
 $maxdays = keys %realdates;
 $maxlimit = $limitdays{$showstats};
 if ($maxlimit > $maxdays) {$maxlimit = $maxdays;}
 if ( ($maxlimit > 0) && ($maxlimit != $maxdays) )
  {print"  (<I>Now showing last $maxlimit days out of a total of $maxdays</I>)<BR>\n";}
  else {$maxlimit = keys %thedates;}
 print "  <TABLE>\n";
 sub sortbyrealdatesref { $realdatesref{$b} <=> $realdatesref{$a}; };
 foreach $key (sort sortbyrealdatesref keys(%realdatesref)) {
  if ($daycounter < $maxlimit) {  
   print<<EOF;
   <TR>
    <TH ALIGN=RIGHT>$key:</TD>
    <TD NOWRAP ALIGN=LEFT>
     <IMG BORDER=1 SRC="$gifdirurl/dot4.gif" HEIGHT=10 WIDTH=$barsize{$key}>
     <A TARGET="_top" HREF="$pagelogurl?$key,=,=,=,=">$realdates{$key}</A>
     <I> $showpercent{$key}</I>
    </TD>
   </TR>
EOF
   $daycounter++;
   }
  }
 print "  </TABLE>\n";
 print "  <P><HR><P>\n";
 }


#===========#
# Kwik Page #
#===========#
sub kwik_page {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %oururls;
 undef $decimal;
 undef $insanepageref;
 undef $key;
 undef $pagecounter;

 foreach $key (sort keys %pagenames) {
  if ($pagenames{$key} > $highest) {$highest=$pagenames{$key};}
  }
 foreach $key (keys %pagenames) {
  $percent{$key} = ($pagenames{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 sub sortbypage { $pagenames{$b} <=> $pagenames{$a}; };
 foreach $key (sort sortbypage keys(%pagenames)) {
  $insanepageref=$key;
  $insanepageref=~ s/ /=/g;
  if ($pagecounter < 1) {
   print<<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>ִ  :</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT><A TARGET="_top" HREF="$pageindex{$key}">$key</A></TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<A TARGET="_top" HREF="$pagelogurl?=,=,$insanepageref,$pageindex{$key},=">$pagenames{$key}</A>
           <I> ($percentage{$key} %)</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $pagecounter++;
   }
  }
 }


#==============#
# Kwik browser #
#==============#
sub kwik_browser {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef $decimal;
 undef $key;
 undef $browsercounter;

 foreach $key (keys %browsers) {
  if ($browsers{$key} > $highest) {$highest=$browsers{$key};}
  }
 foreach $key (keys %browsers) {
  $percent{$key} = ($browsers{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 sub sortbybrowser { $browsers{$b} <=> $browsers{$a}; };
 foreach $key (sort sortbybrowser keys(%browsers)) {
  if ($browsercounter < 1) {
   print<<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>ִ  :</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$key</TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<A TARGET="_top" HREF="$pagelogurl?=,=,=,=,$key">$browsers{$key}</A>
           <I> ($percentage{$key} %)</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $browsercounter++;
   }
  }
 }


#===============#
# Kwik hostname #
#===============#
sub kwik_hostname {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef $decimal;
 undef $space;
 undef $key;
 undef $hostcounter;

 if ($fullhost != 1) {$space = " ";} else {$space = "";}
 foreach $key (keys %hostnames) {
  if ($hostnames{$key} > $highest) {$highest=$hostnames{$key};}
  }
 foreach $key (keys %hostnames) {
  $percent{$key} = ($hostnames{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
  {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 sub sortbyhostname { $hostnames{$b} <=> $hostnames{$a}; };
 foreach $key (sort sortbyhostname keys(%hostnames)) {
  if ($hostcounter < 1) {
   print<<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>ִ  :</B></TD></TR>
         <TR> 
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$key$space</TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<A TARGET="_top" HREF="$pagelogurl?=,$key,=,=,=">$hostnames{$key}</A>
           <I> ($percentage{$key} %)</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $hostcounter++;
   }
  }
 }


#======================#
# Kwik day of the week #
#======================#
sub kwik_dayweek {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;
 undef $weekdaycounter;

 foreach $key (keys %days) {
  if ($days{$key} > $highest) {$highest=$days{$key};}
  }
 foreach $key (keys %days) {
  $barsize{$key} = int(($days{$key} * 250) / $highest);
  $percent{$key} = ($days{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  if ($percentage{$key} == 0) 
   {$showpercent{$key}="";}else{$showpercent{$key}="($percentage{$key} %)";}
  }
 sub sortbydayofweek { $days{$b} <=> $days{$a}; };
 foreach $key (sort sortbydayofweek keys(%days)) {
  if ($weekdaycounter < 1) {
   print<<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>ְ :</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$key</TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<B>$days{$key}</B> <I> $showpercent{$key}</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $weekdaycounter++;
   }
  }
 }


#=======================#
# Kwik day of the month #
#=======================#
sub kwik_daymonth {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef $decimal;
 undef $key;
 undef $datecounter;

 foreach $key (keys %dates) {
  if ($dates{$key} > $highest) {$highest=$dates{$key};}
  }
 foreach $key (keys %dates) {
  $percent{$key} = ($dates{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
  {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 sub sortbymonthday { $dates{$b} <=> $dates{$a}; };
 foreach $key (sort sortbymonthday keys (%dates)) {
  if ($datecounter < 1) { 
   print <<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B> :</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT><U>$key</U><B>/31</B></TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<B>$dates{$key}</B><I> ($percentage{$key} %)</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $datecounter++;
  }
  }
 }


#===========#
# Kwik hour #
#===========#
sub kwik_hour {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef %barsize;
 undef $decimal;
 undef $key;
 undef $hourcounter;
 undef $realtime;
 undef $time_notation;

 foreach $key (keys %hours) {
  if ($hours{$key} > $highest) {$highest=$hours{$key};}
  }
 foreach $key (keys %hours) {
  $percent{$key} = ($hours{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
  {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  }
 sub sortbyhour { $hours{$b} <=> $hours{$a}; };
 foreach $key (sort sortbyhour keys (%hours)) {
  if ($hourcounter < 1) {
   if ($key > 11) 
    {$time_notation = "pm";}else{$time_notation = "am";}
   if ($key > 12) {$realtime = $key - 12;}else{$realtime = $key;}
   if ($key == 0) {$realtime = "12";$time_notation = "am";}
   print <<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>Ϻ  ð:</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$realtime $time_notation</TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<B>$hours{$key}</B><I> ($percentage{$key} %)</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $hourcounter++;
   }
  }
 }


#==========#
# Kwik day #
#==========#
sub kwik_day {
 $highest=0;
 undef %percent;
 undef %percentage;
 undef $decimal;
 undef $key;
 undef $daycounter;
 undef %realdates;
 undef %realdatesref;

 foreach $key (keys %thedates) {
  ($junk,$junk,$junk,$mday,$mon,$year,$junk,$junk,$junk)=localtime($key);
  $mon = $mon + 1;
  $realdate = sprintf ("%2d/%2d/%2d",$mon,$mday,$year);
  $realdate =~ s/ /0/g;
  $realdates{$realdate} = $realdates{$realdate} + $thedates{$key};
  $realdatesref{$realdate}=$key;
  }
 foreach $key (keys %realdates) {
  if ($realdates{$key} > $highest) { $highest=$realdates{$key};}  
  }
 foreach $key (keys %realdates) {
  $percent{$key} = ($realdates{$key} / $nooflines) * 100;
  if (rindex($percent{$key},".") != -1)
   {$decimal = substr($percent{$key},rindex($percent{$key},"."),3);}
  if ($decimal == 0) {$decimal="";}
  $percentage{$key} = int($percent{$key}).$decimal;
  if ($percentage{$key} == 0) 
   {$showpercent{$key}="";}else{$showpercent{$key}="($percentage{$key} %)";}
  }
 sub sortbyrealdates { $realdates{$b} <=> $realdates{$a}; };
 foreach $key (sort sortbyrealdates keys(%realdates)) {
  if ($daycounter < 1) {  
   print<<EOF;
        <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
         <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B> :</B></TD></TR>
         <TR>
          <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$key</TD>
          <TD NOWRAP WIDTH=50% ALIGN=LEFT>
           [<A TARGET="_top" HREF="$pagelogurl?$key,=,=,=,=">$realdates{$key}</A>
           <I> $showpercent{$key}</I>]
          </TD>
         </TR>
        </TABLE>
EOF
   $daycounter++;
   }
  }
 }


#============#
# Kwik today #
#============#
sub kwik_today {
 undef $percent;
 undef $percentage;
 undef $decimal;
 undef $today_connections;

 $datevalues = 0;

 ($tsecond,$tminute,$thour,$tmday,$tmon,$tyear,$junk,$junk,$junk)=localtime(time);
 $tmon = $tmon + 1;
 $today = sprintf ("%2d/%2d/%2d",$tmon,$tmday,$tyear);
 $today =~ s/ /0/g;

 foreach $key (keys %thedates) {
  ($junk,$junk,$junk,$mday,$mon,$year,$junk,$junk,$junk)=localtime($key);
  $mon = $mon + 1;
  $realdate = sprintf ("%2d/%2d/%2d",$mon,$mday,$year);
  $realdate =~ s/ /0/g;
  if ($today eq $realdate) {$today_connections = $today_connections + $thedates{$key};}
  }

 if ($today_connections > 0) {
  $percent = ($today_connections / $nooflines) * 100;
  if (rindex($percent,".") != -1)
   {$decimal = substr($percent,rindex($percent,"."),3);}
  if ($decimal == 0) {$decimal = "";}
  $percentage = int($percent).$decimal;
  if ($percentage == 0) 
   {$showpercent = "";}else{$showpercent = "($percentage %)";}
  }

 if ($today_connections > 0) {  
  print<<EOF;
      </TD></TR>\n       <TR><TD>
       <TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>
        <TR><TD NOWRAP $tableheadercolor ALIGN=LEFT COLSPAN=2><B>Ϻ  :</B></TD></TR>
        <TR>
         <TD NOWRAP WIDTH=50% ALIGN=RIGHT>$today</TD>
         <TD NOWRAP WIDTH=50% ALIGN=LEFT>
          [<A TARGET="_top" HREF="$pagelogurl?$today,=,=,=,=">$today_connections</A>
          <I> $showpercent</I>]
         </TD>
        </TR>
       </TABLE>
EOF
    }
 }


#=============#
# Wrapping up #
#=============#
print <<EOF;
  <CENTER>
   <FONT SIZE=2>
   <A TARGET="_top" HREF="http://www.dadream.co.kr/~jang22">P&G CGIġ </A>
   </FONT>
  </CENTER>
 </BODY>
</HTML>
EOF

exit;
